(ns clj-http.foo
  (:require [clj-http.client :as client]))

(def url-list-from-symbols ["http://www.aoeu.com" "http://www.aoeu.com/bad"])

(defn async-gets [urls]
  (doall (map #(future (client/get % {:throw-exceptions false}))
              urls)))

(let [gets (async-gets (take 10 url-list-from-symbols))
      fail? (fn [req-fut] (not (client/success? @req-fut)))]
  (map fail? gets))
